#!/bin/bash
# Wenn diese Datei im Editor geoeffnet wird, muessen Sie
# diese ausfuehrbar machen! ("Datei als Programm ausfuehren")
# Der Name dieser Datei muss gleich sein wie EasyTax,
# jedoch ".sh" statt ".jar". Z.B. "ETAG12.sh" <=> "ETAG12.jar"

if [ ! -n "$BASH" ]; then 
	bash $0
	exit 1
fi

if [ -L $0 ] ; then
  BASEDIR="$(dirname $(readlink $0))"
  APP="$(basename $(readlink $0))"
else
  BASEDIR="$(dirname $0)"
  APP="$(basename $0)"
fi

APP=${APP:0:6}
JAR="$BASEDIR/$APP.jar"
if [ -d "$BASEDIR/lib" ] ; then
  BASEDIR="$BASEDIR/lib"
fi

if [ -f $JAR ]; then
  echo "$JAR"
else
  echo "Fehler: Datei nicht gefunden: '$JAR'"
  exit
fi
DIR="$HOME"
if [ -d "$HOME/Documents" ]; then
  DIR="$HOME/Documents"
elif [ -d "$HOME/Dokumente" ]; then
  DIR="$HOME/Dokumente"
elif [ -d "$HOME/Desktop" ]; then
  DIR="$HOME/Desktop"
fi
FILE="$DIR/${APP}_$(date '+%y-%m-%d')"

JAVA="$INSTALL4J_JAVA_HOME_OVERRIDE/bin/java"
if [ ! -f "$JAVA" ]; then
	JAVA="$BASEDIR/../jre/bin/java"
fi
if [ ! -f "$JAVA" ]; then
	JAVA="$BASEDIR/../.install4j/jre.bundle/Contents/Home/jre/bin/java"
fi
if [ ! -f "$JAVA" ]; then
	JAVA="$JAVA_HOME/bin/java"
fi
if [ ! -f "$JAVA" ]; then
	JAVA="$JRE_HOME/bin/java"
fi
if [ ! -f "$JAVA" ]; then
	JAVA="java"
fi;

command -v "$JAVA" >/dev/null 2>&1 || { echo "Java konnte nicht gefunden werden. Installieren Sie Oracle Java von http://java.com/" >&2; }

OUT="$FILE.out.txt"
ERR="$FILE.err.txt"
touch $OUT
touch $ERR
echo "*** $(date) ***" >> $OUT 2>> $ERR
"$JAVA" -jar "$JAR" --verbose >> $OUT 2>> $ERR &
echo "EasyTax wird gestartet..."
echo "Siehe Logfiles:"
echo $OUT
echo $ERR
wait

if [ -x "$(command -v xdg-open)" ]; then
	echo "Logfiles werden geoeffnet..."
  xdg-open $OUT &
  xdg-open $ERR &
elif [ "$(uname)" == "Darwin" ]; then
  echo "Logfiles werden geoeffnet..."
  open -a TextEdit $OUT
  open -a TextEdit $ERR
fi
